#include <stdio.h>
#include "arduino.h"
#include "request.h"
#include <iostream>
#include <stdlib.h>
#include <unistd.h>

using namespace std;

int main(){
	int mode, speed, dist,value_switch;
	double volt;
	//char buf[256];
	run_state_t state;
	
	
	if(arduino_open() != 0) return -1;
	request_set_runmode(STP, 0, 0);
	system("python linenotify_ver2.py c_con_open");
	sleep(0.1);

	while(1){
		
		
		//data.txt sansyou
		int i;
		FILE *file;
		file = fopen("data.txt","r");
		fscanf(file,"%d",&i);
		fclose(file);
		
		if(i == 49){
			//spreadsheetkousinmade
			i = 99;
		}
		
		if(i == 0 || i == 30|| i == 31 || i == 32 || i == 40 || i == 50|| i == 51|| i == 52 || i==90 || i == 91 || i == 666 ){
			mode = i;
			system("python line99write.py");
		}else if(i != 99){
			printf("0:stop  1:straight  2:rotate  3:get_mode  4:get_volt  5:quit  30:arm_start  31:arm_end  32:SW_ST  40:start  50:call  51:line  52:spread  90:shutdown  91:reboot\n");
			scanf("%d",&mode);
		}else{
			//void
			mode = 99;
		}
		
		switch(mode){		
		case 0:
			system("python linenotify_ver2.py 00stop");
			sleep(0.1);
			request_set_runmode(STP, 0, 0);
			break;
		case 1:
			system("python linenotify_ver2.py 01straight");
			sleep(0.1);
			printf("speed? [cm/s]\n");
			scanf("%d",&speed);
			printf("dist? [cm]\n");
			scanf("%d",&dist);
			
			request_set_runmode(STR, speed, dist);
			while(1){
				request_get_runmode(&state, &speed, &dist);
				if( state == STP ) break;
			}

			break;
		case 2:
			system("python linenotify_ver2.py 02rotate");
			sleep(0.1);
			printf("speed? [deg/s]\n");
			scanf("%d",&speed);
			
			printf("angle? [deg]\n");
			scanf("%d",&dist);
			
			request_set_runmode(ROT, speed, dist);
			while(1){
				request_get_runmode(&state, &speed, &dist);
				if( state == STP ) break;
			}
			break;
		case 3:
			system("python linenotify_ver2.py 03get_mode");
			sleep(0.1);
			request_get_runmode(&state, &speed, &dist);
			printf("state = %s\n",((state == STR) ? "STR" : (state == ROT) ? "ROT" : "STP"));
			break;
		case 4:
			system("python linenotify_ver2.py 04get_volt");
			sleep(0.1);
			request_get_batt(&volt);
			printf("batt = %4.2lf\n", volt);
			break;
		case 5:
			system("python linenotify_ver2.py 05quit");
			sleep(0.1);
			return 0;
		case 30://arm_start
			system("python linenotify_ver2.py 30arm_startrequest ");
			sleep(0.1);
			request_30();
			//return 0;
			break;
		case 31://arm_end
			system("python linenotify_ver2.py 31arm_endrequest ");
			sleep(0.1);
			request_31();
			//return 0;
			break;
		case 32://SW_ST	
			system("python linenotify_ver2.py 32SW_STrequest ");
			sleep(0.1);
			while(1){
				//system("python line.py");
				request_32(&value_switch);
				printf("%d\n",value_switch);
				if (value_switch == 0){
					request_set_runmode(STR, 30, 1000);
					while(1){
						request_get_runmode(&state, &speed, &dist);
						request_32(&value_switch);
						if (value_switch == 1) break;
						if( state == STP ) break;
					}
				}else{
				//system("python line.py");
				request_set_runmode(STP,0,0);
				int i;
				FILE *file;
				file = fopen("data.txt","r");
				fscanf(file,"%d",&i);
				fclose(file);
				if(i == 49) {
					system("python line99write.py");
					break;
					}
				} 
			}
			
			//break;
			break;
		case 40://start
		{
			system("python linenotify_ver2.py 40startrequest ");
			sleep(0.1);
			//SoundCallPhase
			system("python linenotify_ver2.py 40-1SoundCallPhase");
			sleep(0.1);
			int k = 16;
			while(1){
				if(k > 100){
					system("python test.py");
					k = 0;
				}
				k = k + 1;
				sleep(0.1);
				request_32(&value_switch);
				if (value_switch == 0) break;
				int i;
				FILE *file;
				file = fopen("data.txt","r");
				fscanf(file,"%d",&i);
				fclose(file);
				
				if(i == 49) break;
			}
			
			
			
			//OudanPhase
			system("python linenotify_ver2.py 40-2OudanPhase");
			sleep(0.1);
			
			while(1){
				//system("python line.py");
				request_32(&value_switch);
				printf("%d\n",value_switch);
				if (value_switch == 0){
					request_set_runmode(STR, 30, 1000);
					while(1){
						request_get_runmode(&state, &speed, &dist);
						request_32(&value_switch);
						if (value_switch == 1) break;
						if( state == STP ) break;
					}
				}else{
				//system("python line.py");
				request_set_runmode(STP,0,0);
				//sleep(3);
				//int i;
				//FILE *file;
				//file = fopen("data.txt","r");
				//fscanf(file,"%d",&i);
				//fclose(file);
				//printf("%d\n",i);
				//if (i == 49){
				//break;
				//} 
				}
				
			int i;
			FILE *file;
			file = fopen("data.txt","r");
			fscanf(file,"%d",&i);
			fclose(file);
				
			if(i == 49) break;
			}
			
			
			
			//FinishPhase
			system("python line99write.py");
			system("python linenotify_ver2.py 40-3FinishPhaseThanks!");
			
			sleep(0.1);
			
			break;
		}
		case 50://speaker
			system("python linenotify_ver2.py 50speakerrequest ");
			sleep(0.1);
			system("python test.py");
			break;
		case 51://linenotify
			system("python linenotify_ver2.py 51linenotifyrequest ");
			sleep(0.1);
			system("python linenotify.py");
			break;
		case 52://spreadsheet
			//system("python line.py");
			//sleep(0.1);
			//int j;
			//FILE *file;
			//file = fopen("data.txt","r");
			//fscanf(file,"%d",&j);
			//fclose(file);
			//printf("%d\n",j);
			break;
		case 90://shutdown
			system("python linenotify_ver2.py 90shutdownrequest");
			sleep(1);
			system("sudo shutdown -h now");
			break;
		case 91://reboot
			system("python linenotify_ver2.py 91rebootrequest");
			sleep(1);
			system("sudo shutdown -r now");
			break;
		case 666://(**<)
			system("python linenotify_ver2.py 666AKUMArequest");
			system("python line99write.py");
			sleep(0.1);
			printf("^(*<*)^\n");
			break;
		default:
			break;
		}
	}
	
	arduino_close();
	return 0;
}
