import cv2

cap = cv2.VideoCapture(0)

while True:
    ret,frame = cap.read()
    img = cv2.cvtColor(frame,cv2.COLOR_BGR2GRAY)
    ret,bw_img = cv2.threshold(img,0,255,cv2.THRESH_OTSU)
    
    img_size = bw_img.size
    white_pixels = cv2.countNonZero(bw_img)
    black_pixels = bw_img.size - white_pixels
    
    print('White_Area='+str(white_pixels/img_size*100)+'%')
    print('Black_Area='+str(black_pixels/img_size*100)+'%')
    
    cv2.imshow('OpenCV',bw_img)
    k = cv2.waitKey(1)
    if k == 32:
        break

cap.release()
cv2.destroyAllWindows()