# -*- coding: utf-8 -*-
#LINE999WRITE

import gspread
import json
import time
from oauth2client.service_account import ServiceAccountCredentials



#2つのAPIを記述しないとリフレッシュトークンを3600秒毎に発行し続けなければならない
scope = ['https://spreadsheets.google.com/feeds','https://www.googleapis.com/auth/drive']

#認証情報設定
#ダウンロードしたjsonファイル名をクレデンシャル変数に設定（秘密鍵、Pythonファイルから読み込みしやすい位置に置く）
credentials = ServiceAccountCredentials.from_json_keyfile_name('/home/pi/mg4_pi_ver4.0.0/mirs2104-e7f8474b6c22.json', scope)

#OAuth2の資格情報を使用してGoogle APIにログインします。
gc = gspread.authorize(credentials)

#共有設定したスプレッドシートキーを変数[SPREADSHEET_KEY]に格納する。
SPREADSHEET_KEY = '1We8BMP5AhyNA9HOUsjGhnB5kTXBYrvFQD-WD1cXRcwM'

#共有設定したスプレッドシートのシート1を開く
worksheet = gc.open_by_key(SPREADSHEET_KEY).sheet1

A1data = 99
#A1セルの値を受け取る
import_value = worksheet.update_acell('A1',A1data)




