#include <stdio.h>
#include "arduino.h"
#include "request.h"
#include <unistd.h>
#include "uss.h"

int main(){
	//変数定義
	int mode, speed, dist;
	double volt;
	long uss_l, uss_r;
	int flag_l = 0, flag_r = 0;
	//char buf[256];
	run_state_t state;
	//Arduinoの認識
	if(arduino_open() != 0) return -1;
	//超音波センサの認識	
	if(uss_open_l() != 0){
		printf(" left uss open faild !!\n");
		flag_l = -1;
	}
	if(uss_open_r() != 0){
		printf(" right uss open faild !!\n");
		flag_r = -1;
	}
	if( flag_l == -1 && flag_r == -1) return -1;



	//while文
	while(1){	
			printf("speed? [cm/s]\n");
			scanf("%d",&speed);
			printf("dist? [cm]\n");
			scanf("%d",&dist);
			
			request_set_runmode(STR, speed, dist);
			while(1){
				uss_l = uss_get_l();
				usleep(500 * 1000);
				uss_r = uss_get_r();
				usleep(500 * 1000);
				if(uss_l < 50 || uss_r < 50){
					printf("emergency stop !!\n");
					request_set_runmode(STP, 0, 0);
					usleep(2*1000000);
					request_set_runmode(STR, speed, -30);
					usleep(2*1000000);	
					request_set_runmode(STP, 0, 0);
					break;
				}
				request_get_runmode(&state, &speed, &dist);
				if( state == STP ) break;
			}
	}
	
	arduino_close();
	return 0;
}
