#include <stdio.h>
#include "arduino.h"
#include "request.h"
#include <unistd.h>
#include "uss.h"
#include "io.h"

int main(){
	//変数定義
	int mode, speed, dist;
	double volt;
	long uss_l, uss_r;
	int flag_l = 0, flag_r = 0;
	int sw_f, sw_l, sw_r;
	//char buf[256];
	run_state_t state;
	//Arduinoの認識
	if(arduino_open() != 0) return -1;
	//スイッチの認識
	if(io_open() != 0) return -1;
	//while文
	while(1){	
			printf("speed? [cm/s]\n");
			scanf("%d",&speed);
			printf("dist? [cm]\n");
			scanf("%d",&dist);
			
			request_set_runmode(STR, speed, dist);
			while(1){
				
				io_get_sw(&sw_f, &sw_l, &sw_r);				
				if(sw_l == 0 || sw_r == 0){
					printf("emergency stop !!\n");
					request_set_runmode(STP, 0, 0);
					usleep(2*1000000);
					request_set_runmode(STR, speed, -30);
					usleep(2*1000000);	
					request_set_runmode(STP, 0, 0);
					break;
				}
				request_get_runmode(&state, &speed, &dist);
				if( state == STP ) break;
				usleep(100 * 1000);
			}
	}
	
	arduino_close();
	return 0;
}
